<script lang="ts">
import Vue from 'vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'BySolutionList',
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },

  data() {
    return {
      modal: false,
    };
  },
  methods: {
    handleClick() {
      this.modal = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
  },
});
</script>

<template>
  <section
    :id="data.id"
    class="solution-list"
    :class="{ 'light-background': data.light_background }"
  >
    <SlpContainer style="padding: 0">
      <SlpRow class="resources-block-container">
        <SlpColumn
          :cols="12"
          class=""
          :data-aos="data.header_animation"
          :data-aos-duration="data.header_animation_duration"
        >
          <SlpTypography
            tag="h2"
            variant="heading2-bold"
            class="slp-mt-32 slp-mb-64"
            >{{ data.title }}
          </SlpTypography>

          <SlpTypography tag="p" variant="body1" class="slp-mb-32">
            {{ data.header }}
          </SlpTypography>

          <div class="solution-list__content slp-mb-32">
            <ul>
              <li v-for="item in data.items" :key="item" class="list-element">
                <SlpIcon size="md" :icon="data.icon"> </SlpIcon>
                <span class="slp-text-body1-bold" v-html="$md.render(item)" />
              </li>
            </ul>
          </div>

          <SlpTypography tag="p" variant="body1" class="slp-mb-32">
            {{ data.footer }}
          </SlpTypography>
          <!--
            Here's another way to ahieve, but the scoped classes make a mess

          <div
            ref="customMD"
            class="solution-list__content MD"
            v-html="$md.render(data.content)"
          ></div> -->

          <SlpButton
            :data-ga-location="data.cta.ga_location"
            :data-ga-name="data.cta.ga_name"
            :href="data.cta.href"
            class="slp-mb-16"
            @click.native="handleClick()"
            >{{ data.cta.text }}
            <SlpIcon class="slp-ml-8" icon="gl-play" />
          </SlpButton>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>

    <SolutionsVideoModal
      v-show="modal"
      light-background
      :visible="modal"
      @close="modal = false"
    >
      <template #body>
        <lite-vimeo
          :videoid="getVimeoVideoId(createVideoSource(data.cta.video))"
          :title="data.cta.text ?? 'Video'"
          autoplay
        ></lite-vimeo>
      </template>
    </SolutionsVideoModal>
  </section>
</template>

<style lang="scss">
.solution-list {
  padding: $spacing-32 0;
  @media (min-width: $breakpoint-lg) {
    padding: $spacing-96 0;
  }
  position: relative;
  // pseudo-background
  &:after {
    content: '';
    position: absolute;
    width: 150vw;
    height: 100%;
    top: 0;
    left: -30vw;
    z-index: -1;
    background: $color-surface-800;
  }

  .solution-list__content {
    .list-element {
      & div:first-child {
        margin-right: $spacing-8;
      }
      display: flex;
      align-items: flex-start;
      margin-bottom: $spacing-16;

      @media (min-width: $breakpoint-lg) {
        align-items: center;
      }
    }
  }
}
</style>
